<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed video_type
 * @property mixed video_url
 * @property mixed images
 */
class OfferRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('offers'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules =
            [
                'status'=>'required|in:true,false',
                'image'=>'required',
                'second_image'=>'required',
            ];

        foreach (languages() as $lang)
        {
            $lang_rules =
                [
                    'name_'.$lang->local=> 'required',
                    'description_'.$lang->local=> 'required',
                    'second_name_'.$lang->local=> 'required',
                    'second_description_'.$lang->local=> 'required',
                ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('offers');
        $local = getCurrentLocale();
        $attributes=[
            'status' => __('offers.status'),
            'image' => __('offers.image'),
            'second_image' => __('offers.second_image'),
        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => __('offers.name') .' ' . $lang->local,
                'description_'.$lang->local=> __('offers.description') .' ' . $lang->local,
                'second_name_'.$lang->local => __('offers.name') .' ' . $lang->local,
                'second_description_'.$lang->local=> __('offers.description') .' ' . $lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
